#ifndef HTML_BOOLATTR_HH
#define HTML_BOOLATTR_HH

#include "html/Attrib.hh"
#include <string>

namespace html {
  class writer;

  class boolAttr : public attrib {
  public:
    boolAttr(bool value=true);
    boolAttr(const boolAttr& x);
    ~boolAttr(void);
    attrib* clone(void) const;
    bool isDefault(void) const;
    bool hasArg(void) const;
    void putAttr(writer& w) const;
    void setValue(bool value=true);
    bool operator==(const boolAttr& x) const;

  private:
    bool mValue;
  };

}

#endif //  HTML_BOOLATTR_HH
