#include "lmsg/Grinder.hh"
#include <string.h>

using namespace lmsg;

Grinder::~Grinder(void) {}
Grinder::Grinder(void) {
    //----------------------------------  Test Big/Little endian
    union {
        char byte[4];
        unsigned int  num;} fred;

    unsigned int tval=0;
    for (int i=0 ; i<4 ; i++) {
        fred.byte[i] = i;
        tval = (tval << 8) | fred.byte[i];}
    if (tval == fred.num) mBigEnd = true;
    else                  mBigEnd = false;
}

void
Grinder::swap8(const char* in[], char* out[], size_type n) {
    if (mBigEnd) {
        size_type nByte = n*8;
        if (*in != (const char*) *out) memcpy(*out, *in, nByte);
	*in  += nByte;
	*out += nByte;
    } else {
        const int* ip = (const int*) *in;
	int*       op = (int*) *out;
	for (size_type i=0 ; i<n ; i++) {
	    int t = *ip++;
	    *op++ = *ip++;
	    *op++ = t;
	}
	swap4(const_cast<const char**>(out), out, 2*n);
    }
}

void
Grinder::swap4(const char* in[], char* out[], size_type n) {
    if (mBigEnd) {
        size_type nByte = n*4;
        if (*in != (const char*) *out) memcpy(*out, *in, nByte);
	*in  += nByte;
	*out += nByte;
    } else {
        const unsigned short* ip = (const unsigned short*)*in;
	unsigned short*       op = (unsigned short*)*out;
	for (size_type i=0 ; i<n ; i++) {
	    unsigned short t = *ip++;
	    *op++ = *ip++;
	    *op++ = t;
	}
	swap2(const_cast<const char**>(out), out, 2*n);
    }
}

void
Grinder::swap2(const char* in[], char* out[], size_type n) {
    if (mBigEnd) {
        size_type nByte = n*2;
        if (*in != (const char*) *out) memcpy(*out, *in, nByte);
	*in  += nByte;
	*out += nByte;
    } else {
        const char* ip = in[0];
	char*       op = out[0];
	for (size_type i=0 ; i<n ; i++) {
	    char t = *ip++;
	    *op++  = *ip++;
	    *op++  = t;
	}
	*in  = ip;
	*out = op;
    }
}

void
Grinder::swapr(const char* in[], char* out[], size_type n) {
    if (mBigEnd) {
        size_type nByte = n*8;
        if (*in != (const char*) *out) memcpy(*out, *in, nByte);
	*in  += nByte;
	*out += nByte;
    } else {
        const char* ip = in[0];
	char*       op = out[0];
	for (size_type i=0 ; i<n ; i++) {
	    for (size_type j=0 ; j<6 ; j++) *op++ = *ip++;
	    char t = *ip++;
	    *op++  = *ip++;
	    *op++  = t;
	}
	*in  = ip;
	*out = op;
    }
}
