#ifndef LMSG_SOCKETPOOL_HH
#define LMSG_SOCKETPOOL_HH
#include "gmutex.hh"
#include <list>

namespace lmsg {
  class Socket;

  class SocketPool {
  public:
    typedef unsigned long index_t;
    enum requestType {s_new, s_reusable};
  public:
    ~SocketPool(void);
    SocketPool(void);
    Socket* getSocket(requestType type, const MsgAddr* addr=0);
    void returnSocket(Socket* buff);
  private:
    typedef std::list<Socket*> SocketList;
    typedef SocketList::iterator Pool_Iter;
    SocketList mClient;
    thread::mutex mMux;
  }; // SocketPool class

} // namespace lmsg

extern lmsg::SocketPool defaultLMsgSocketPool;

#endif // LMSG_SOCKETPOOL_HH
