#!/usr/bin/tcsh 

#######################################
#        Initialize the stuff         #
#######################################

if (! $?DMTHOME) setenv DMTHOME /opt/dmt
if (! $?DMTVERSION) setenv DMTVERSION new
setenv LD_LIBRARY_PATH $DMTHOME/$DMTVERSION/lib:/opt/CERN/root/lib:/usr/local/lib:/usr/openwin/lib

set WGET="wget -t 1 -T 5 -q"
set TNOW="when 0 %s"

setenv T_start `$TNOW`

set sd=$HOME/dmtspi/cache
set td=$DMTHOME/$DMTVERSION/etc/Spi

mkdir -p $sd
setenv TD "/tmp"

# Identify machine

setenv gn   `cat /etc/nodename`
setenv g    `cat $td/HOST.lookup | awk '{if($1==gn) print $2}' gn=$gn`
setenv gip  `cat $td/HOST.lookup | awk '{if($1==gn) print $3}' gn=$gn`
setenv gLN  `cat $td/HOST.lookup | awk '{if($1==gn) print $4}' gn=$gn`
cat $td/nose_base.html | nawk '{gsub("ligo-wa",gip);gsub("COMPNAME",g);gsub("LIGO",gLN); print $0} END{print "<br><br>"}' gLN=$gLN gip=$gip g=$g > $sd/{$g}_spiT.html

  echo '<table BORDER COLS=4 WIDTH="100%">'                          >> $sd/{$g}_spiT.html
  echo '<tr><td>Created at</td>'                                     >> $sd/{$g}_spiT.html
  echo '<td><b><font color="#FF0000">' `$TNOW` '</td>'        >> $sd/{$g}_spiT.html
  echo '<td><b><font color="#FF00DD">' `date` '</td>'                >> $sd/{$g}_spiT.html
  echo '<td><b><font color="#0000FF">' `date -u` '</td></tr>'        >> $sd/{$g}_spiT.html
  echo '</table><br>'                                                >> $sd/{$g}_spiT.html 

if -e  $sd/{$g}_Errors.log rm $sd/{$g}_Errors.log

# Define remote directories

if ("$gip" == "ligo-wa") then
#  setenv dh "/opt/CDS/a/apacheFiles/htdocs/gds" 
  setenv dh "/cvs/cds/lho/web/gds"
  setenv dw "http://blue.ligo-wa.caltech.edu/gds"
endif
if ("$gip" == "ligo-la") then
  setenv dh "/import/space/apacheFiles/htdocs/gds"
  setenv dw "http://london.ligo-la.caltech.edu/gds"
endif

setenv dd "$dh/dmt/Monitors"
setenv d2 "$dw/dmt/Monitors"

setenv IsSluggish "NO"

#######################################
#  Prepare DMT diagnostic info files  #
#######################################

mkdir -p $dd/$g
mkdir -p $dd/$g/Stats

ls /export/home/ops/logs/DpushM-{$gn}-* >& /dev/null
if ( ! $status ) then
    foreach list ( `ls /export/home/ops/logs/DpushM-{$gn}-*`  )
    if ( -e $dd/$g/Stats/$list:t == 0 ) cp -p $list $dd/$g/Stats/
    end

    setenv list `ls /export/home/ops/logs/DpushM-{$gn}-* | sort -u | tail -1`
    if ( -e $dd/$g/Stats/$list:t == 1 ) rm $dd/$g/Stats/$list:t
    cp -p $list $dd/$g/Stats/
endif

#######################################
# Set up the list of running monitors #
#######################################

setenv HTMB  '<br><br><b><font size=+1><a href="LINK">PROCESS</a></b>&nbsp;&nbsp;[<a href="PLINK">PARENT</a>]</font>&nbsp;&nbsp;&nbsp;&nbsp;'
/usr/local/bin/top -d1 -s1 -b 1000 > $sd/top_$g.list
$DMTHOME/$DMTVERSION/bin/smdump | awk 'BEGIN {i=0} {if($1=="Consumer"){ i=1;}; if(i==1){if($2=="pid"){i=2}}; if(i>1){if(!($2=="pid")){printf(" %s \n", $2)}}} END { }' > $sd/smdump_$g.list

rm $sd/{$g}_OK_Procs*.html   >& /dev/null
rm $sd/{$g}_MISS_Procs*.html >& /dev/null
rm $sd/{$g}_SUPP_Procs*.html >& /dev/null
rm $sd/{$g}_ALL_Procs.txt    >& /dev/null
rm $sd/{$g}_Done_Procs.txt   >& /dev/null
rm $sd/{$g}_*_Mon*.html       >& /dev/null


setenv MID `ps -ef | grep procmgt | grep perl | grep ops | grep dmt | nawk '{a=$2} END{print a}'`

set plistd="/export/home/ops/Process_List_$gn"
foreach PRC ( `ls $plistd | grep -v "\-%" ` )
    if ( -e $plistd/$PRC/disable) continue;
  setenv PID "NA"
  setenv CWD "NA"
  setenv OUT "NA"
  setenv EXE "NA"
  setenv HTM "NA"
  setenv RST "NA"
  setenv TRN "NA"
  foreach list ( `ls -l $plistd/$PRC | grep "\->" | nawk '{printf("%sAAAAA%s\n",$9,$11)}'` )
    setenv One `echo $list | nawk '{gsub("AAAAA", " "); print $1}'`
    setenv Two `echo $list | nawk '{gsub("AAAAA", " "); print $2}'`
    if ( "$One" == "pid" )          setenv PID $Two
    if ( "$One" == "cwd" )          setenv CWD $Two
    if ( "$One" == "dmt_output" )   setenv OUT $Two
    if ( "$One" == "exe" )          setenv EXE $Two:t
    if ( "$One" == "html_output" )  setenv HTM $Two
    if ( "$One" == "restarts" )     setenv RST $Two
    if ( "$One" == "trend_output" ) setenv TRN $Two
  #echo $PRC : $One $Two
  end

  setenv SID `ps -ef | grep ops | grep $PID | nawk 'BEGIN{a=0} {if($3==P) a=$2;} END{print a}' P=$PID`
  if ( "$SID" == "0" ) then
    setenv SID `ps -ef | nawk 'BEGIN{a=0} {if($3==P) a=$2;} END{print a}' P=$MID`
  #echo "BB:", $list, $EXE, $PID, $SID, $MID
    if ( "$SID" == "$MID" ) setenv SID $PID  
  #echo "AA:", $list, $EXE, $PID, $SID, $MID
  endif

  #rm $sd/{$g}_{$PRC}_TOP.html >& /dev/null
  #cat $dd/$g/TOPinfo.html | grep $SID | grep $EXE > $sd/{$g}_{$PRC}_TOP.html

  echo $PID >> $sd/{$g}_Done_Procs.txt
  echo $SID >> $sd/{$g}_Done_Procs.txt

  setenv BEF `cat $TD/Before_$g.list | nawk 'BEGIN{a=-1} {if($1==p) {a=$2}; if($1==s){a=$2};} END{print a}' p=$PID s=$SID`
  setenv AFT `cat $TD/After_$g.list  | nawk 'BEGIN{a=-1} {if($1==p) {a=$2}; if($1==s){a=$2};} END{print a}' p=$PID s=$SID`
  setenv NAT `echo JJ | nawk '{d=-1;if(b>0){if(a>0){d=a-b;}}} END{print d}' b=$BEF a=$AFT` 
  setenv EAT `echo $NAT | nawk '{o="IDLE"; if($1<0){o="NA"}; if($1>20){o="RUNS"};} END{print o}'`

  setenv HTM "$dw/monitor_reports/"
  if ( -d $dh/monitor_reports/$EXE == 1 ) setenv HTM $dw/monitor_reports/$EXE
  if ( -d $dh/monitor_reports/$PRC == 1 ) setenv HTM $dw/monitor_reports/$PRC

  setenv RUN "N"
  if ( "$PID" != "NA" ) then
    setenv SMD `cat $sd/smdump_$g.list | grep " $SID "`
    if ( "$SID" == "$SMD" ) setenv RUN "Y"
    if ( "$PID" == "$SMD" ) setenv RUN "Y"
    setenv SMD `cat $sd/smdump_$g.list | grep " $PID "`
    if ( "$PID" == "$SMD" ) setenv RUN "Y"
    if ( "$SID" == "$SMD" ) setenv RUN "Y"
    setenv SMD `cat $sd/top_$g.list | nawk '{ printf(" %s \n", $1) }' | grep " $SID " `
    if ( "$SID" == "$SMD" ) setenv RUN "Y"
    if ( "$PID" == "$SMD" ) setenv RUN "Y"
    setenv SMD `cat $sd/top_$g.list | nawk '{ printf(" %s \n", $1) }' | grep " $PID " `
    if ( "$PID" == "$SMD" ) setenv RUN "Y"
    if ( "$SID" == "$SMD" ) setenv RUN "Y"
  endif

  echo $SID >> $sd/{$g}_Done_Procs.txt

  setenv SUP "N"
  setenv XXX `echo $EXE | /usr/xpg4/bin/grep -f$td/Support.proc`
  if ( "$EXE" == "$XXX" ) setenv SUP "Y"

  # echo `date` $g "-" $XXX $EXE "|" $OUT $PID $SID $CWD "|" $RUN $SUP

  setenv DOC $d2/UnDocumented
  if ( -d $dd/$EXE == 1 ) setenv DOC $d2/$EXE
  if ( -d $dd/$PRC == 1 ) setenv DOC $d2/$PRC

  setenv SYN $dd/UnDocumented/UnDocumented.synopsis
  if ( -e $dd/$EXE/{$EXE}.synopsis == 1 ) setenv SYN $dd/$EXE/{$EXE}.synopsis
  if ( -e $dd/$PRC/{$PRC}.synopsis == 1 ) setenv SYN $dd/$PRC/{$PRC}.synopsis

  echo $PID $SID $EXE $PRC $RUN $SUP $RST $DOC $HTM $OUT $TRN $CWD >> $sd/{$g}_ALL_Procs.txt

  setenv FILE /dev/null
  setenv COL "CCCCCC"
  setenv STATUS "Unknown"
  setenv BALL "yellow"
  setenv SUPPORT "n"
  if ( "$RUN" == "Y" ) then
    if ( "$SUP" == "N" ) then
      setenv FILE $sd/{$g}_OK_Procs.html
      setenv COL "0000DD"
      setenv STATUS "Running"
      setenv BALL "green"
    endif
    if ( "$SUP" == "Y" ) then
      setenv FILE $sd/{$g}_SUPP_Procs.html
      setenv COL "AAAAAA"
      setenv STATUS "Support"
      setenv BALL "green"
      setenv SUPPORT "nS"
    endif
  endif
  if ( "$RUN" == "N" ) then
    setenv FILE $sd/{$g}_MISS_Procs.html  
    setenv COL "FF2211"
    setenv STATUS "<b>MISSING</b>"
    setenv BALL "red"
  endif

  echo '<br><br><b><font size=+1><a href="'$HTM'">'$PRC'</a></b>&nbsp;&nbsp;[<a href="'$DOC'">'$EXE'</a>]</font>&nbsp;&nbsp;&nbsp;&nbsp;' >> $FILE
  cat $SYN >> $FILE
  echo '<br>[Resurrectable: <b>'$RST'</b> times]&nbsp;&nbsp;[<a href="'$HTM'">Results</a>]&nbsp;&nbsp;[<a href="'$DOC'">Description</a>]&nbsp;&nbsp;[Trend Output: '$TRN']&nbsp;&nbsp;' >> $FILE
  echo '<br>[DMT Output: '$OUT']&nbsp;&nbsp;[Instance PID: '$PID']&nbsp;&nbsp;[Parent PID: '$SID']&nbsp;&nbsp;[Configured from: '$CWD']&nbsp;&nbsp;' >> $FILE
  cat $sd/top_$g.list | grep $SID | grep $EXE | nawk '{printf("<br>PID: <b>%s</b>  |  USER: <b>%s</b>  |  CPU: <b>%s</b>  |  SIZE: <b>%s</b>  RES: <b>%s</b> | TIME: <b>%s</b> \n",$1,$2,$10,$6,$7,$9)}'  >> $FILE

  if ( "$EAT" == "IDLE" ) then
    echo '<br><font color="#FF0000">IDLE : Consumed ' $NAT ' frames during 512 seconds. </font>' >> $FILE
    setenv IsSluggish "YES"  
    setenv COL "FF0000"
    setenv STATUS "<b>IDLE</b>"
    setenv BALL "red"
  endif
  if ( "$EAT" == "RUNS" ) then
    echo "<br>Running : Consumed " $NAT " frames during 512 seconds." >> $FILE
  endif

  echo '<font size=+1><b><a name="'$PRC'" href="'{$HTM}'">'$PRC'</a></b>&nbsp;[<a href="'{$DOC}'">'$EXE'</a>]</font>&nbsp;&nbsp;' >> {$FILE:r}_spi.html

  echo '<!-- '$PRC'--><tr><td><img SRC="pix/ball_'{$BALL}'.gif"></td><td><a href="'{$HTM}'"><b>'$PRC'</b></a></td><td><font color="#'$COL'">'$STATUS'</font></td><td><a href="'{$DOC}'">'$EXE'</a></td><td><a href="'$d2/{$g}_spi.html'">'{$g}'</a></td><td>'{$gLN}'</td></tr>' >> $sd/{$g}_{$gLN}_Mo{$SUPPORT}.html
end   

rm $sd/pid_$g.txt >& /dev/null
rm $sd/{$g}_Rogue_Procs*.html   >& /dev/null
ps -ef | grep -v "root" | grep -v "tcsh" | nawk '{print $2}' > $sd/Running_$g.list 
$td/../../bin/smdump | awk 'BEGIN {i=0} {if($1=="Consumer"){ i=1;}; if(i==1){if($2=="pid"){i=2}}; if(i>1){if(!($2=="pid")){print $2;}}} END { }' | /usr/xpg4/bin/grep -v -f$sd/{$g}_Done_Procs.txt | /usr/xpg4/bin/grep -f$sd/Running_$g.list > $sd/pid_$g.txt

setenv FILE $sd/{$g}_Rogue_Procs.html
foreach PID (`cat $sd/pid_$g.txt`)
  setenv EXE `/usr/local/bin/top -d1 -s1 -b 1000 | nawk '{print $1,$11}' | grep $PID | nawk '{print $2}'`
  
  setenv HTM "$dw/monitor_reports/"
  if ( -d $dh/monitor_reports/$EXE == 1 ) setenv HTM $dw/monitor_reports/$EXE

  setenv DOC $d2/UnDocumented
  if ( -d $dd/$EXE == 1 ) setenv DOC $d2/$EXE

  setenv SYN $dd/UnDocumented/UnDocumented.synopsis
  if ( -e $dd/$EXE/{$EXE}.synopsis == 1 ) setenv SYN $dd/$EXE/{$EXE}.synopsis

  echo $PID $EXE $DOC $HTM >> $sd/{$g}_ALL_Procs.txt

  echo '<br><br><b><font size=+1><a name="'$EXE'" href="'{$HTM}'">'$EXE'</a></b></font>&nbsp;&nbsp;&nbsp;&nbsp;' >> $FILE
  cat $SYN >> $FILE
  echo '&nbsp;&nbsp;[<a href="'{$DOC}'">Description</a>]' >> $FILE
  cat $sd/top_$g.list | grep $PID | grep $EXE | nawk '{printf("<br>PID: <b>%s</b>  |  USER: <b>%s</b>  |  CPU: <b>%s</b>  |  SIZE: <b>%s</b>  RES: <b>%s</b> | TIME: <b>%s</b>\n",$1,$2,$10,$6,$7,$9)}'  >> $FILE

  echo '<b><font size=+1><a href="'{$HTM}'">'$EXE'</a></b>&nbsp;[<a href="'{$DOC}'">Doc</a>]</font>&nbsp;&nbsp;' > {$FILE:r}_spi.html

  setenv COL "FF0099"
  setenv STATUS "<b>Testing</b>"
  setenv BALL "purple"
  echo '<!-- '$EXE'--><tr><td><img SRC="pix/ball_'{$BALL}'.gif"></td><td><a href="'{$HTM}'"><b>'$EXE'</b></a></td><td><font color="#'$COL'">'$STATUS'</font></td><td><a href="'{$DOC}'">'$EXE'</a></td><td><a href="'$d2/{$g}_spi.html'">'{$g}'</a></td><td>'{$gLN}'</td></tr>' >> $sd/{$g}_{$gLN}_Mon.html
end

rm $sd/{$g}_spiMaker.html >& /dev/null

if ( "$IsSluggish" == "YES" ) then
  echo '<font color="#FF0000"><b><blink>IDLE processes exist</blink></b></font><br>' > $sd/{$g}_spiMaker.html
else
  touch $sd/{$g}_spiMaker.html
endif

if ( -e $sd/{$g}_OK_Procs_spi.html == 1 ) then
  echo '<font color="#0000FF"><font size=+1>ProcessManaged:</font>' >> $sd/{$g}_spiMaker.html
  cat $sd/{$g}_OK_Procs_spi.html >> $sd/{$g}_spiMaker.html
  echo '</font><br>' >> $sd/{$g}_spiMaker.html
endif
if ( -e $sd/{$g}_MISS_Procs_spi.html == 1 ) then
  echo '<font color="#FF0000"><font size=+1>MissingMonitor:</font>' >> $sd/{$g}_spiMaker.html
  cat $sd/{$g}_MISS_Procs_spi.html >> $sd/{$g}_spiMaker.html
  echo '</font><br>' >> $sd/{$g}_spiMaker.html
endif
if ( -e $sd/{$g}_Rogue_Procs_spi.html == 1 ) then
  echo '<font color="#555555"><font size=+1>DevelopingMons:</font>' >> $sd/{$g}_spiMaker.html 
  cat $sd/{$g}_Rogue_Procs_spi.html >> $sd/{$g}_spiMaker.html
  echo '</font><br>' >> $sd/{$g}_spiMaker.html
endif
if ( -e $sd/{$g}_SUPP_Procs_spi.html == 1 ) then
  echo '<font color="#00FF44"><font size=+1>SupportProcess:</font>' >> $sd/{$g}_spiMaker.html
  cat $sd/{$g}_SUPP_Procs_spi.html >> $sd/{$g}_spiMaker.html
  echo '</font><br>' >> $sd/{$g}_spiMaker.html
endif

cp $sd/{$g}_spiMaker.html $dd/{$g}_spiMaker.html
cp $sd/{$g}_*_Mon.html $dd/

# Retrieve LLO products

if ( "$g" == "STONE" ) then 

  cat $td/HOST.lookup | grep "ligo-la" | nawk '{printf("%s/%s_\n",$5,$2)}' > $sd/Things2wget.list

  foreach NM (`cat $sd/Things2wget.list`)
    cd $dd
    rm -f $dd/{$NM:t}spi.html
    $WGET {$NM}spi.html

    cd $sd
    rm -f $sd/{$NM:t}spiMaker.html
    rm -f $sd/{$NM:t}LLO_Mon.html
    $WGET {$NM}spiMaker.html
    $WGET {$NM}LLO_Mon.html
  end

  cat $td/spiHeader.html > $sd/spiT.html

  echo '<table BORDER COLS=4 WIDTH="100%">'                          >> $sd/spiT.html
  echo '<tr><td>Created at</td>'                                     >> $sd/spiT.html
  echo '<td><b><font color="#FFDD00">' `$TNOW` '</td>'        >> $sd/spiT.html
  echo '<td><b><font color="#FF00DD">' `date` '</td>'                >> $sd/spiT.html
  echo '<td><b><font color="#0000FF">' `date -u` '</td></tr>'        >> $sd/spiT.html
  echo '</table><br>'                                                >> $sd/spiT.html

  foreach OBS ( LHO LLO CIT MIT )
    foreach COMP (`cat $td/HOST.lookup | grep $OBS  | awk '{print $2}'`)
      setenv WHT  `cat $td/HOST.lookup | grep $COMP | awk '{print $5}'` 
      echo '<font color="#000088"><font size=+1><a href="'{$WHT}{$COMP}'_spi.html">'$COMP'</a></font></font><br>' >> $sd/spiT.html
      cat $sd/{$COMP}_spiMaker.html >> $sd/spiT.html
      echo '<hr SIZE=1 WIDTH="75%">' >> $sd/spiT.html
    end
  end

  cat $td/spiTrailer.html >> $sd/spiT.html

  mv $sd/spiT.html $dd/spiT.html
  mv $dd/spiT.html $dd/spiC.html

# Creates monitor indexed file

  foreach IFO ( _LLO _LHO "" )

  cat $td/spiMHeader{$IFO}.html > $sd/spiMT{$IFO}.html

  echo '<table border="0" COLS=4 WIDTH="100%">'                      >> $sd/spiMT{$IFO}.html
  echo '<tr><td><font color="#333333">Created at : </font></td>'     >> $sd/spiMT{$IFO}.html
  echo '<td><b><font color="#DDDD22">' `$TNOW` '</td>'        >> $sd/spiMT{$IFO}.html
  echo '<td><b><font color="#DD00DD">' `date` '</td>'                >> $sd/spiMT{$IFO}.html
  echo '<td><b><font color="#33FF33">' `date -u` '</td></tr>'        >> $sd/spiMT{$IFO}.html
  echo '</table><br>'                                                >> $sd/spiMT{$IFO}.html
  echo '<table BORDER="0" bgcolor="EEEEEE" bordercolor="#FFFFFF" RULES=ROWS FRAME=HSIDES COLS=6 WIDTH="100%">' >> $sd/spiMT{$IFO}.html
  echo '<tr><td>?OK?</td><td>Monitor instance</td><td>Status</td><td>Description of monitor class</td><td>Host and process details</td><td>Site</td></tr><tr><td>&nbsp;</td><td></td><td></td><td></td><td></td><td></td></tr>' >> $sd/spiMT{$IFO}.html
  
  cat $sd/*{$IFO}_Mon.html | sort -f >> $sd/spiMT{$IFO}.html

  echo '</table><br>'                                                >> $sd/spiMT{$IFO}.html

  cat $sd/Errors.log >> $sd/spiMT{$IFO}.html

  cat $td/spiMTrailer.html >> $sd/spiMT{$IFO}.html

  mv $sd/spiMT{$IFO}.html $dd/spiMT{$IFO}.html
  mv $dd/spiMT{$IFO}.html $dd/spiM{$IFO}.html
  cp $dd/spiM{$IFO}.html $dd/spi{$IFO}.html

  end

endif

# Retrieve LHO products

if ( "$g" == "DELARONDE" ) then 

# Creates monitor indexed file

  setenv IFO "_LLO"

  cat $td/spiMHeader{$IFO}.html > $sd/spiMT{$IFO}.html

  echo '<table border="0" COLS=4 WIDTH="100%">'                      >> $sd/spiMT{$IFO}.html
  echo '<tr><td><font color="#333333">Created at : </font></td>'     >> $sd/spiMT{$IFO}.html
  echo '<td><b><font color="#DDDD22">' `$TNOW` '</td>'        >> $sd/spiMT{$IFO}.html
  echo '<td><b><font color="#DD00DD">' `date` '</td>'                >> $sd/spiMT{$IFO}.html
  echo '<td><b><font color="#33FF33">' `date -u` '</td></tr>'        >> $sd/spiMT{$IFO}.html
  echo '</table><br>'                                                >> $sd/spiMT{$IFO}.html
  echo '<table BORDER="0" bgcolor="EEEEEE" bordercolor="#FFFFFF" RULES=ROWS FRAME=HSIDES COLS=6 WIDTH="100%">' >> $sd/spiMT{$IFO}.html
  echo '<tr><td>?OK?</td><td>Monitor instance</td><td>Status</td><td>Description of monitor class</td><td>Host and process details</td><td>Site</td></tr><tr><td>&nbsp;</td><td></td><td></td><td></td><td></td><td></td></tr>' >> $sd/spiMT{$IFO}.html
  
  cat $sd/*{$IFO}_Mon.html | sort -f >> $sd/spiMT{$IFO}.html

  echo '</table><br>'         >> $sd/spiMT{$IFO}.html
  cat $td/spiMTrailer.html   >> $sd/spiMT{$IFO}.html

  mv $sd/spiMT{$IFO}.html $dd/spiMT{$IFO}.html
  mv $dd/spiMT{$IFO}.html $dd/spiM{$IFO}.html

endif


echo '<tt>' >> $sd/{$g}_spiT.html
if ( -e $sd/{$g}_OK_Procs.html == 1 ) then
  echo '<br><hr SIZE=1 WIDTH="80%">' >> $sd/{$g}_spiT.html
  echo '<br><font color="#0000FF"><font size=+2><b>Monitors running under process manager:</b></font>' >> $sd/{$g}_spiT.html
  cat $sd/{$g}_OK_Procs.html >> $sd/{$g}_spiT.html 
  echo '</font><br>' >> $sd/{$g}_spiT.html 
endif 
if ( -e $sd/{$g}_MISS_Procs.html == 1 ) then
  echo '<br><hr SIZE=1 WIDTH="80%">' >> $sd/{$g}_spiT.html
    echo '<br><font color="#FF0000"><font size=+2><b>Missing monitors:</b></font>' >> $sd/{$g}_spiT.html
  cat $sd/{$g}_MISS_Procs.html >> $sd/{$g}_spiT.html
  echo '</font><br>' >> $sd/{$g}_spiT.html
endif
if ( -e $sd/{$g}_Rogue_Procs.html == 1 ) then
  echo '<br><hr SIZE=1 WIDTH="80%">' >> $sd/{$g}_spiT.html
  echo '<br><font color="#555555"><font size=+2><b>Monitors in testing phase:</b></font>' >> $sd/{$g}_spiT.html
  cat $sd/{$g}_Rogue_Procs.html >> $sd/{$g}_spiT.html
  echo '</font><br>' >> $sd/{$g}_spiT.html
endif
if ( -e $sd/{$g}_SUPP_Procs_spi.html == 1 ) then
  echo '<br><hr SIZE=1 WIDTH="80%">' >> $sd/{$g}_spiT.html
  echo '<br><font color="#00FF44"><font size=+2><b>Support processes:</b></font>' >> $sd/{$g}_spiT.html
  cat $sd/{$g}_SUPP_Procs.html >> $sd/{$g}_spiT.html
  echo '</font><br>' >> $sd/{$g}_spiT.html
endif

echo '</tt>' >> $sd/{$g}_spiT.html
echo '</font><p><hr SIZE=1 WIDTH="80%"><br><br><font color="#000000">' >> $sd/{$g}_spiT.html

#######################################
# Making the tail of the page         #
#######################################

setenv T_stop `$TNOW` 
setenv T_dur  `echo $T_start $T_stop | nawk '{a=$2-$1;} END{print a}'`

cp $sd/{$g}_spiMaker.html $dd/{$g}_spiMaker.html

cat $td/tail.html >> $sd/{$g}_spiT.html
echo `date` >> $sd/{$g}_spiT.html
echo "PM</font></b>" >> $sd/{$g}_spiT.html
setenv rr `cat $dd/$g/TOPinfo.html | grep "<br>CPU&nbsp;states:&nbsp;" | nawk '{gsub("\\&nbsp;"," ");gsub("\\("," ");print 100-$3}'`

# Add tag line (used to check up to date status)
echo '<font color="#CCCCCC"><font size=-2>' >> $sd/{$g}_spiT.html
echo $gip `date '+TI %H %M'` $rr | awk '{a=$3; if($1=="ligo-la") a-=2; if(a<0) a+=24; print "TI", a, $4, $5}' >> $sd/{$g}_spiT.html
echo '</font></font>' >> $sd/{$g}_spiT.html

echo "<br>Script run time: " $T_dur " sec<br>" >> $sd/{$g}_spiT.html

cat $td/refresh.html >> $sd/{$g}_spiT.html

echo "</body>"   >> $sd/{$g}_spiT.html
echo "</html>"   >> $sd/{$g}_spiT.html

# Place html page to public directory

mv $sd/{$g}_spiT.html $dd/{$g}_spiT.html
mv $dd/{$g}_spiT.html $dd/{$g}_spi.html

# Mail out error messages to listed experts

foreach list ( `cat $dd/MailErrorsTo.list` ) 
#if -e $sd/{$g}_Errors.log cat $sd/{$g}_Errors.log | mailx -s "Error message from {$g}" {$list}
end
 
# Clean up junk

#rm $sd/*_$g.list
